import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { CmsArticleCount, CmsArticleCountParam } from './model';


/**
 * 分页查询点赞文章
 */
export async function pageCmsArticleCount(params: CmsArticleCountParam) {
  const res = await request.get<ApiResult<PageResult<CmsArticleCount>>>(
    '/cms/cms-article-count/page',
    {
      params
    }
  );
  if (res.code === 0) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 查询点赞文章列表
 */
export async function listCmsArticleCount(params?: CmsArticleCountParam) {
  const res = await request.get<ApiResult<CmsArticleCount[]>>(
    '/cms/cms-article-count',
    {
      params
    }
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 添加点赞文章
 */
export async function addCmsArticleCount(data: CmsArticleCount) {
  const res = await request.post<ApiResult<unknown>>(
    '/cms/cms-article-count',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 修改点赞文章
 */
export async function updateCmsArticleCount(data: CmsArticleCount) {
  const res = await request.put<ApiResult<unknown>>(
    '/cms/cms-article-count',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 删除点赞文章
 */
export async function removeCmsArticleCount(id?: number) {
  const res = await request.del<ApiResult<unknown>>(
    '/cms/cms-article-count/' + id
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 批量删除点赞文章
 */
export async function removeBatchCmsArticleCount(data: (number | undefined)[]) {
  const res = await request.del<ApiResult<unknown>>(
    '/cms/cms-article-count/batch',
    {
      data
    }
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 根据id查询点赞文章
 */
export async function getCmsArticleCount(id: number) {
  const res = await request.get<ApiResult<CmsArticleCount>>(
    '/cms/cms-article-count/' + id
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}
